#> afkannouncer:app/main.mcfunction
# Execute each minecraft tick

# Recursive call main function
  schedule function afkannouncer:app/main 1t

# Listen for help
  scoreboard players enable @a help.afkannouncer
  execute as @a if score @s help.afkannouncer matches 1 run function afkannouncer:app/help/trigger_help

# Set basic value for time until afk for all players
  execute as @a unless score @s afkannouncer.afk_timer = @s afkannouncer.afk_timer run scoreboard players set @s afkannouncer.afk_timer 300

# Calculate afk_timer_ticks
  execute as @a run scoreboard players operation @s afkannouncer.set_afk_timer_ticks = @s afkannouncer.afk_timer 
  execute as @a run scoreboard players operation @s afkannouncer.set_afk_timer_ticks *= #20 afkannouncer.set_afk_timer_ticks

# Check player position
  # Remove all afk position tags
    tag @a remove afkannouncer.position.x.not_moving
    tag @a remove afkannouncer.position.y.not_moving
    tag @a remove afkannouncer.position.z.not_moving
    tag @a remove afkannouncer.rotation.x.not_moving
    tag @a remove afkannouncer.rotation.y.not_moving
    tag @a remove afkannouncer.sneak_time.not_changing

  # Run functions to check for no movement
    execute as @a at @s run function afkannouncer:app/check_movement/position
    execute as @a at @s run function afkannouncer:app/check_movement/rotation
    execute as @a at @s run function afkannouncer:app/check_movement/sneak

  # Reset afk time if player moves
    scoreboard players set @a[tag=!afkannouncer.position.x.not_moving] afkannouncer.afk_time 0
    scoreboard players set @a[tag=!afkannouncer.position.y.not_moving] afkannouncer.afk_time 0
    scoreboard players set @a[tag=!afkannouncer.position.z.not_moving] afkannouncer.afk_time 0

    scoreboard players set @a[tag=!afkannouncer.rotation.x.not_moving] afkannouncer.afk_time 0
    scoreboard players set @a[tag=!afkannouncer.rotation.y.not_moving] afkannouncer.afk_time 0

    scoreboard players set @a[tag=!afkannouncer.sneak_time.not_changing] afkannouncer.afk_time 0

  # Store last player position
    execute as @a store result score @s afkannouncer.position.x.last run data get entity @s Pos[0] 10000
    execute as @a store result score @s afkannouncer.position.y.last run data get entity @s Pos[1] 10000
    execute as @a store result score @s afkannouncer.position.z.last run data get entity @s Pos[2] 10000

    execute as @a store result score @s afkannouncer.rotation.x.last run data get entity @s Rotation[0] 10000
    execute as @a store result score @s afkannouncer.rotation.y.last run data get entity @s Rotation[1] 10000

  # Reset sneak time
    scoreboard players set @a afkannouncer.sneak_time 0

# If no movement is detected, add 1 to afk_time of player
  scoreboard players add @a[tag=afkannouncer.position.x.not_moving,tag=afkannouncer.position.y.not_moving,tag=afkannouncer.position.z.not_moving,tag=afkannouncer.rotation.x.not_moving,tag=afkannouncer.rotation.y.not_moving,tag=afkannouncer.sneak_time.not_changing] afkannouncer.afk_time 1 

# Listen for trigger afk
  scoreboard players enable @a afk
  execute as @a if score @s afk matches 1 run function afkannouncer:app/triggers/afk

# Listen for trigger config 
  scoreboard players enable @a afkannouncer.config
  execute as @a if score @s afkannouncer.config matches 1 run function afkannouncer:app/triggers/set_config_data with storage afkannouncer:config

# Listen for trigger afkannouncer.color.config
  scoreboard players enable @a afkannouncer.color.config
  execute as @a if score @s afkannouncer.color.config matches 1 run function afkannouncer:app/triggers/afkannouncer.color.config with storage afkannouncer:color

# Run functions to check for color change
  # schedule function afkannouncer:app/color/name_color 3s
  # schedule function afkannouncer:app/color/name_color_short 3s

# Announce AFK
  execute if score &afk_kick afkannouncer.config matches 1 run execute if score &players_decide_on_own afkannouncer.config matches 1 run execute as @a[tag=!afkannouncer.afk,scores={afkannouncer.afk_timer=1..,afkannouncer.individual_afk_kick=0}] if score @s afkannouncer.afk_time >= @s afkannouncer.set_afk_timer_ticks run function afkannouncer:app/announce/afk
  execute if score &afk_kick afkannouncer.config matches 1 run execute if score &players_decide_on_own afkannouncer.config matches 1 run execute as @a[scores={afkannouncer.afk_timer=1..,afkannouncer.individual_afk_kick=0}] if score @s afkannouncer.afk_time >= @s afkannouncer.set_afk_timer_ticks run tag @s[tag=!trigger_afk] add afkannouncer.afk

  execute unless score &afk_kick afkannouncer.config matches 1 run execute as @a[tag=!afkannouncer.afk,scores={afkannouncer.afk_timer=1..}] if score @s afkannouncer.afk_time >= @s afkannouncer.set_afk_timer_ticks run function afkannouncer:app/announce/afk
  execute unless score &afk_kick afkannouncer.config matches 1 run execute as @a[scores={afkannouncer.afk_timer=1..}] if score @s afkannouncer.afk_time >= @s afkannouncer.set_afk_timer_ticks run tag @s[tag=!trigger_afk] add afkannouncer.afk

# Announce Return
  execute as @a[tag=afkannouncer.afk,scores={afkannouncer.afk_time=0, afkannouncer.afk_timer=1..}] at @s run function afkannouncer:app/announce/return
  tag @a[scores={afkannouncer.afk_time=0}] remove afkannouncer.afk

# Show Dimension In Name
  # Equal setting with SDIN
    scoreboard players operation &short_prefix afkannouncer.config = &short_prefix sdin.config
  # Compatibility
    execute as @a[tag=afkannouncer.afk,scores={afkannouncer.afk_timer=1..}] run function afkannouncer:app/team/join
    execute as @a[tag=afkannouncer.afk,scores={afkannouncer.afk_timer=1..}] run function showdiminname:main
    execute as @a[tag=!afkannouncer.afk,scores={afkannouncer.afk_timer=1..}] run function afkannouncer:app/team/leave
    execute as @a[tag=!afkannouncer.afk,scores={afkannouncer.afk_timer=1..}] run function showdiminname:main

# When a player leaves the afk tag is removed
  execute as @a unless score @s afkannouncer.leave_game matches 1 store success score @s afkannouncer.leave_game run tag @s remove afkannouncer.afk